Index: configure.ac.in
===================================================================
RCS file: /var/cvs/videolan/vlc/configure.ac.in,v
retrieving revision 1.245
diff -u -r1.245 configure.ac.in
--- configure.ac.in	3 Jun 2003 22:18:57 -0000	1.245
+++ configure.ac.in	5 Jun 2003 22:26:43 -0000
@@ -1942,6 +1942,57 @@
 fi
 
 dnl
+dnl  GSM 6.10 module
+dnl 
+AC_ARG_ENABLE(libgsm,
+  [  --enable-libgsm      GSM 6.10 and MSGSM audio decoder module (default disabled)])
+if test "x${enable_libgsm}" = "xyes"
+then
+  AC_ARG_WITH(libgsm-tree,
+    [    --with-libgsm-tree=PATH libgsm tree for static linking])
+
+  dnl
+  dnl test for !(--with-libgsm-tree)
+  dnl
+  if test "x${with_libgsm_tree}" == "xno" -o "x${with_libgsm_tree}" == "x";then
+    CPPFLAGS="${CPPFLAGS_save} ${CPPFLAGS_libgsm}"
+    LDFLAGS="${LDFLAGS_save} ${LDFLAGS_libgsm}"
+    AC_CHECK_HEADERS(libgsm/gsm.h libgsm/private.h)
+    AC_CHECK_LIB( libgsm, libgsm_init, [
+      BUILTINS="${BUILTINS} gsm610"
+      LDFLAGS_gsm610="${LDFLAGS_libgsm} -lgsm" ],
+       [ AC_MSG_ERROR([Could not find libgsm on your system: you may get it from http://kbs.cs.tu-berlin.de/~jutta/toast.html. Alternatively y
+ou can use --disable-gsm610 to disable the libgsm plugin.]) ])
+    LDFLAGS="${LDFLAGS_save}"
+    CPPFLAGS="${CPPFLAGS_save}"
+  fi
+
+  dnl
+  dnl test for --with-libgsm-tree
+  dnl
+  if test "x${with_libgsm_tree}" != "xno" -a "x${with_libgsm_tree}" != "x";then
+    AC_MSG_CHECKING(for libgsm.a in ${with_libgsm_tree})
+    real_libgsm_tree="`cd ${with_libgsm_tree} 2>/dev/null && pwd`"
+    if test "x${real_libgsm_tree}" = x; then
+      dnl  The given directory can't be found
+      AC_MSG_RESULT(no)
+      AC_MSG_ERROR([cannot cd to ${with_libgsm_tree}])
+    fi
+    if test -f "${real_libgsm_tree}/lib/libgsm.a"; then
+      dnl  Use a custom libgsm
+      AC_MSG_RESULT(${real_libgsm_tree}/lib/libgsm.a)
+      BUILTINS="${BUILTINS} gsm610"
+      LDFLAGS_gsm610="${LDFLAGS_gsm610} -L${real_libgsm_tree}/lib -lgsm"
+      CPPFLAGS_gsm610="${CPPFLAGS_gsm610} -I${real_libgsm_tree}/inc"
+    else
+      dnl  The given libgsm wasn't built
+      AC_MSG_RESULT(no)
+      AC_MSG_ERROR([cannot find ${real_libgsm_tree}/lib/libgsm.a, make sure you compiled libgsm in ${with_libgsm_tree}])
+    fi
+  fi
+fi
+
+dnl
 dnl  Video plugins
 dnl
Index: include/codecs.h
===================================================================
RCS file: /var/cvs/videolan/vlc/include/codecs.h,v
retrieving revision 1.3
diff -u -r1.3 codecs.h
--- include/codecs.h	3 Dec 2002 17:00:15 -0000	1.3
+++ include/codecs.h	5 Jun 2003 22:26:43 -0000
@@ -74,6 +74,8 @@
 #define  WAVE_FORMAT_MPEG               0x0050 /* Microsoft Corporation */
 #define  WAVE_FORMAT_MPEGLAYER3         0x0055 /* ISO/MPEG Layer3 Format Tag */
 #define  WAVE_FORMAT_DOLBY_AC3_SPDIF    0x0092 /* Sonic Foundry */
+#define  WAVE_FORMAT_GSM610             0x31   /* Microsoft Corporation */
+#define  WAVE_FORMAT_MSN                0x32   /* Microsoft Corporation */
 
 /* Need to check these */
 #define WAVE_FORMAT_A52             0x2000
Index: modules/codec/Modules.am
===================================================================
RCS file: /var/cvs/videolan/vlc/modules/codec/Modules.am,v
retrieving revision 1.15
diff -u -r1.15 Modules.am
--- modules/codec/Modules.am	20 May 2003 21:35:52 -0000	1.15
+++ modules/codec/Modules.am	5 Jun 2003 22:26:43 -0000
@@ -14,3 +14,4 @@
 SOURCES_libmpeg2 = modules/codec/libmpeg2.c
 SOURCES_rawvideo = modules/codec/rawvideo.c
 SOURCES_quicktime = modules/codec/quicktime.c
+SOURCES_gsm610 = modules/codec/gsm.c
Index: modules/demux/asf/asf.c
===================================================================
RCS file: /var/cvs/videolan/vlc/modules/demux/asf/asf.c,v
retrieving revision 1.29
diff -u -r1.29 asf.c
--- modules/demux/asf/asf.c	22 May 2003 21:42:43 -0000	1.29
+++ modules/demux/asf/asf.c	5 Jun 2003 22:26:43 -0000
@@ -232,26 +232,38 @@
                     p_sp->i_stream_number );
             switch( i_codec )
             {
-                case( 0x01 ):
+                case( WAVE_FORMAT_PCM ):
                     p_stream->p_es->i_fourcc =
                         VLC_FOURCC( 'a', 'r', 'a', 'w' );
                     break;
-                case( 0x50 ):
-                case( 0x55 ):
+                case( WAVE_FORMAT_MPEG ):
+                case( WAVE_FORMAT_MPEGLAYER3 ):
                     p_stream->p_es->i_fourcc =
                         VLC_FOURCC( 'm','p','g','a' );
                     break;
-                case( 0x2000 ):
+                case( WAVE_FORMAT_A52 ):
                     p_stream->p_es->i_fourcc =
                         VLC_FOURCC( 'a','5','2',' ' );
                     break;
-                case( 0x160 ):
+                case( WAVE_FORMAT_WMA1 ):
                     p_stream->p_es->i_fourcc =
                         VLC_FOURCC( 'w','m','a','1' );
                     break;
-                case( 0x161 ):
+                case( WAVE_FORMAT_WMA2 ):
                     p_stream->p_es->i_fourcc =
                         VLC_FOURCC( 'w','m','a','2' );
+                    break;
+                case( WAVE_FORMAT_WMA3 ):
+                    p_stream->p_es->i_fourcc =
+                        VLC_FOURCC( 'w','m','a','3' );
+                    break;
+                case( WAVE_FORMAT_GSM610 ):
+                    p_stream->p_es->i_fourcc =
+                        VLC_FOURCC( 'm','s','3','1' );
+                    break;
+                case( WAVE_FORMAT_MSN ):
+                    p_stream->p_es->i_fourcc =
+                        VLC_FOURCC( 'm','s','3','2' );
                     break;
                 default:
                     p_stream->p_es->i_fourcc =
Index: modules/demux/avi/avi.c
===================================================================
RCS file: /var/cvs/videolan/vlc/modules/demux/avi/avi.c,v
retrieving revision 1.49
diff -u -r1.49 avi.c
--- modules/demux/avi/avi.c	26 May 2003 14:59:37 -0000	1.49
+++ modules/demux/avi/avi.c	5 Jun 2003 22:26:45 -0000
@@ -230,6 +230,10 @@
                     return VLC_FOURCC( 'w', 'm', 'a', '1' );
                 case WAVE_FORMAT_WMA2:
                     return VLC_FOURCC( 'w', 'm', 'a', '2' );
+                case WAVE_FORMAT_GSM610:
+                    return VLC_FOURCC( 'm', 's', '3', '1' );
+                case WAVE_FORMAT_MSN:
+                    return VLC_FOURCC( 'm', 's', '3', '2' );
                 default:
                     return VLC_FOURCC( 'm', 's',
                                        ( i_codec >> 8 )&0xff, i_codec&0xff );
Index: modules/demux/avi/libavi.h
===================================================================
RCS file: /var/cvs/videolan/vlc/modules/demux/avi/libavi.h,v
retrieving revision 1.10
diff -u -r1.10 libavi.h
--- modules/demux/avi/libavi.h	27 Apr 2003 13:55:51 -0000	1.10
+++ modules/demux/avi/libavi.h	5 Jun 2003 22:26:45 -0000
@@ -159,16 +159,6 @@
 #define FOURCC_I263         VLC_FOURCC('I','2','6','3')
 #define FOURCC_i263         VLC_FOURCC('i','2','6','3')
 
-/* Sound formats */
-#define WAVE_FORMAT_UNKNOWN         0x0000
-#define WAVE_FORMAT_PCM             0x0001
-#define WAVE_FORMAT_MPEG            0x0050
-#define WAVE_FORMAT_MPEGLAYER3      0x0055
-#define WAVE_FORMAT_A52             0x2000
-#define WAVE_FORMAT_WMA1            0x0160
-#define WAVE_FORMAT_WMA2            0x0161
-
-
 #define AVI_CHUNK_COMMON            \
     vlc_fourcc_t i_chunk_fourcc;    \
     uint64_t i_chunk_size;          \
Index: modules/demux/wav/wav.c
===================================================================
RCS file: /var/cvs/videolan/vlc/modules/demux/wav/wav.c,v
retrieving revision 1.16
diff -u -r1.16 wav.c
--- modules/demux/wav/wav.c	21 May 2003 10:02:55 -0000	1.16
+++ modules/demux/wav/wav.c	5 Jun 2003 22:26:45 -0000
@@ -356,6 +356,23 @@
     return( ReadPES( p_input, pp_pes, p_wf->nBlockAlign ) );
 }
 
+static int GSM_GetFrame( input_thread_t *p_input,
+                               WAVEFORMATEX   *p_wf,
+                               pes_packet_t   **pp_pes,
+                               mtime_t        *pi_length )
+{
+    int i_samples;
+
+    /* read samples for 50ms of */
+    i_samples = p_wf->nSamplesPerSec * p_wf->nChannels / 20;
+
+    *pi_length = (mtime_t)1000000 *
+                 (mtime_t)i_samples /
+                 (mtime_t)p_wf->nSamplesPerSec;
+
+    return( ReadPES( p_input, pp_pes, p_wf->nBlockAlign ) );
+}
+
 /*****************************************************************************
  * WAVInit: check file and initializes structures
  *****************************************************************************/
@@ -486,6 +503,12 @@
             msg_Dbg( p_input, "found ima adpcm audio format" );
             p_demux->i_fourcc = VLC_FOURCC( 'm', 's', 0x00, 0x11 );
             p_demux->GetFrame = IMA_ADPCM_GetFrame;
+            p_demux->psz_demux = strdup( "" );
+            break;
+        case( WAVE_FORMAT_GSM610 ):
+            msg_Dbg( p_input, "found gsm 6.10 audio format" );
+            p_demux->i_fourcc = VLC_FOURCC( 'm', 's', '3', '1' );
+            p_demux->GetFrame = GSM_GetFrame;
             p_demux->psz_demux = strdup( "" );
             break;
         default:
